(function initProxy () {
  let electron = require('electron');
  let session = electron.remote.session;
  window.ElectronProxy = {
    formatter: {
      expires: {
        key: 'expirationDate',
        value: val => new Date(val).getTime() / 1000
      },
      secure: {
        key: 'secure',
        value: val => !!val
      },
    },
    getCookie: function () {
      return session.defaultSession.cookies.get({})
        .then((cookies) => {
          return cookies.map(item => `${item.name}=${item.value}`).join('; ');
        });
    },
    setCookie: function (val) {
      var cookieObject = {};
      val.split(';').forEach((o, idx) => {
        var args = o.split('=');
        var key = args[0], value = args[1], formatter = this.formatter[key];
        if (idx === 0) {
          cookieObject.name = key;
          cookieObject.value = value || '';
        } else if (formatter) {
          key = formatter.key;
          value = formatter.value(value);
          cookieObject[key] = value;
        }
      });
      cookieObject.url = cookieObject.url || 'https://www.youku.com';
      return session.defaultSession.cookies.set(cookieObject);
    }
  };
  window.mtopProxy = {
    hostname: 'acs.youku.com',
    protocol: 'https',
    getDocumentCookie: ElectronProxy.getCookie,
    setDocumentCookie: ElectronProxy.setCookie
  };
})();
